#!/usr/local/bin/python
#
# $Id: bttvtrss.py,v 0.1 2004/04/11 15:55:26 magnus Exp $
#
# BSD license applies to this script
# (C) Copyright 2004 Magnus Bodin; magnus@bodin.org; http://x42.com/software/
#

import os, re, shutil, time, urllib, urlparse

# feedparser comes from http://diveintomark.org/projects/feed_parser/
import feedparser 

##############
# Config here

feedurl = 'http://66.199.180.26/~tvt/tvt.xml'

# torrentdir is the directory where _all_ matching torrent gets archived
# you may remove them here when they don't appear in the rssfeed again
torrentdir = '/vol1/film/torrents/'

# activedir is the directory where all active torrents are copied for download
# (this is typically the directory monitored by btlaunchmany.py
activedir = '/vol1/film/active/'

# regexp file with your choice of "subscriptions"
research = 'tvtrss.re'

# set to 1 if no output is desired
quiet = 0

#
##############

def read_search(file):
    fh = open(file)
    return fh.readlines()

def new_torrent(file):
    return not os.path.isfile( torrentdir + file )
    
def get_torrent(tfile, rssitem, s):
    ul = urllib.URLopener()
    uo = ul.retrieve(rssitem['link'], torrentdir + tfile)

def print_queueing(tfile, item, s):
    print time.asctime()
    print "  Queueing(" + s + "): " + tfile
    print "    Title: " + item['title']
    print "    URL: " + item['link']

def match_new_torrent(tfile, item, s):
    result = 0
    s = s.strip()
    if len(s) > 0:
        if new_torrent(tfile):
            if re.search(s, tfile, re.I) or re.search(s, item['title'], re.I):
                result = 1
    return result

def bt_regexp_match_queue(tfile, item, lines):
    for s in lines:
        if match_new_torrent(tfile, item, s):
            get_torrent(tfile, item, s)
            shutil.copyfile(torrentdir + tfile, activedir + tfile)
            if not quiet: print_queueing(tfile, item, s)


## main 

search = read_search(research)
data = feedparser.parse(feedurl)
for item in data['items']:
    fmatch = re.search('([^\/]+.torrent$)', item['link'], re.I)
    if fmatch:
        tfile = fmatch.group(1)
        bt_regexp_match_queue(tfile, item, search)

## end
